#### minicom

Для доступа к меню конфигурации
```bash
sudo minicom -s
```

```bash
            +-----------[конфигурация]-----------+
            | Каталоги и файлы                   |
            | Протоколы                          |
            | Настройка последовательного порта  |
            | Модем и дозвон                     |
            | Экран и клавиатура                 |
            | Сохранить настройки как dfl        |
            | Сохранить настройки как...         |
            | Выход                              |
            | Выход из Minicom                   |
            +------------------------------------+

```

*при использовании нуль-модемного кабеля, адресом последовательного порта в linux будет  
COM1 -  /dev/ttyS0  
COM2 - /dev/ttyS1  
и т.д. В случаях, когда используется адаптер USB-to-COM, в качестве порта ввода-вывода будет использоваться  
/dev/ttyUSB0 или /dev/ttyUSB1.*

После физического подключения, увидеть используемый порт
```bash
dmesg | grep tty
```

Выбираем пункт "Настройка последовательного порта".
```bash
    +-----------------------------------------------------------------------+
    | A - Последовательный порт          : /dev/ttyUSB0                     |
    | B - Размещение lock-файла          : /var/lock                        |
    | C - Программа при выходе           :                                  |
    | D - Программа при запуске          :                                  |
    | E - Скорость/Чётность/Биты         : 115200 8N1                       |
    | F - Аппаратное управление потоком  : Нет                              |
    | G - Программное управление потоком : Нет                              |
    |                                                                       |
    |    Какую настройку изменить?                                          |
    +-----------------------------------------------------------------------+
```
После внесения необходимых изменений сохраняем настройки, выбрав пункт "Сохранить настройки как dfl". Это изменит настройки запуска программы, используемые по умолчанию.

```bash
                                              +---------------------------+
                                              |                           |
            +-----------[конфигурация]--------|  Конфигурация сохранена   |
            | Каталоги и файлы                |                           |
            | Протоколы                       +---------------------------+
            | Настройка последовательного порта  |
            | Модем и дозвон                     |
            | Экран и клавиатура                 |
            | Сохранить настройки как dfl        |
            | Сохранить настройки как...         |
            | Выход                              |
            | Выход из Minicom                   |
            +------------------------------------+
```
Если выбрать пункт "Сохранить настройки как.." и указать имя файла настроек, например "cisco", то это не изменит настройки по умолчанию и в дальнейшем можно будет запускать программу с конкретными параметрами, указав имя файла с настройками. Настройки сохраняются в файлах `minirc.DEVICE_NAME` в папке `/etc/minicom/`
```bash
minicom cisco
```
В завершении настройки переходим к пункту "Выход" и если все настроено правильно, то будет установлен сеанс подключения по последовательному порту.


**Запуск minicom с аргументами**

Minicom можно запускать без выполнения настроек в оконном режиме. Для этого достаточно выполнить запуск программы с заданными аргументами.

Для подключения к устройству с помощью адаптера USB-to-COM со скоростью 38400:
```bash
minicom -D /dev/ttyUSB0 -b 38400
```

Для подключения к устройству с использованием нуль-модемного кабеля:
```bash
minicom -D /dev/ttyS0 -b 38400
```

***

#### Передача файлов

После запуска программы увидим окно с подсказкой
```bash
Добро пожаловать в minicom 2.7.1                                                              
                                                                                              
ПАРАМЕТРЫ: I18n                                                                               
Дата компиляции Dec 23 2019, 02:06:26.                                                        
Port /dev/ttyUSB0, 12:20:47                                                                   
                                                                                              
Нажмите CTRL-A Z для получения подсказки по клавишам                                          
                                                                                              
```

1. Необходимо определить директорию из которой будут загружаться файлы
`Ctrl+A o`  
`Каталоги и файлы`  
`B - Каталог для отправки` - указать полный путь к папке, в которой будут лежать файлы для отправки  
*если не указывать папку, будет предложено выбрать файл из домашней директории пользователя, при этом, перемещаться по каталогам возможности нет*

2. Отправка файла
`Ctrl+A z`  
`s` - для отправки файла  
В следующем окне укажем `xmodem` и пробелом выберем файл который необходимо передать, нажав «Enter» запустим процесс передачи.

*файл будет загружаться со скоростью, которая указана в настройках при подключении в Кб/с, как в dial-up модемах из детства :)*

