#### Сетевой мост (Bridge)
*объединение в бридж встроенного сетевого интерфейса Ethernet и USB сетевой карты*

1. Установить пакет `bridge-utils`
```bash
sudo apt-get install bridge-utils
```
2. Создать бридж `br0` и задать ему IP адрес
*после подключения USB сетевой карты, в Raspberry имеются следующие сетевые интерфейсы:
`eth0` - встроенный интерфейс Ethernet
`eth1` - интерфейс USB сетевой карты
`wlan0` - беспроводной интерфейс*
*объединим в бридж проводные интерфейсы `eth0` `eth1`*
```bash
sudo nano /etc/network/interfaces
```
для получения адреса от DHCP сервера:
```
# Настройка интерфейсов вручную, чтобы избежать конфликтов, например с network manager
iface eth0 inet manual
iface eth1 inet manual

auto br0
iface br0 inet dhcp
bridge_ports eth0 eth1
```
для ручной настройки IP адреса:
```
# Настройка интерфейсов вручную, чтобы избежать конфликтов, например с network manager
iface eth0 inet manual
iface eth1 inet manual

# Настройки бриджа
auto br0
iface br0 inet static
    bridge_ports eth0 eth1
        address 192.168.5.7
        netmask 255.255.255.0
```
3. Необходимо запретить использование интерфейсов `eth0` `eth1` в dhcpcd
```bash
sudo nano /etc/dhcpcd.conf
```
вставить следующую строку
```
denyinterfaces eth0 eth1
```
4. Восстановление Wi-Fi
*после задания статического IP адреса в `/etc/network/interfaces` не работает беспроводная сеть*
*для восстановления возможности использования Wi-Fi необходимо:*
- отключить службу `dhcpcd`
```bash
sudo systemctl disable dhcpcd
sudo systemctl enable networking
```
или
- запретить использование беспроводного интерфейса службой dhcpcd
```bash
sudo nano /etc/dhcpcd.conf
```
вставить следующую строку
```
denyinterfaces wlan0
```

вне зависимости от выбранного способа, настройки беспроводной сети необходимо произвести вручную
```bash
sudo nano /etc/network/interfaces
```
добавить
```bash
# wlan
auto wlan0
iface wlan0 inet dhcp
        wpa-conf /etc/wpa_supplicant/wpa_supplicant.conf

```
задать параметры конкретной беспроводной сети
```bash
sudo nano /etc/wpa_supplicant/wpa_supplicant.conf
```
добавить
```
country=RU

network={
	ssid="название сети"
	psk="пароль"
}

```
*в документации описан способ, при котором можно зашифровать отображение пароля
https://www.raspberrypi.org/documentation/configuration/wireless/wireless-cli.md*
5. Перезагрузить Raspberry для вступления изменений в силу
```bash
sudo reboot
```