# Шпаргалка по командам samba-tool

Больше информации здесь - <https://xinux.net/index.php/Samba-tool>

## Пользователи и группы

### Создать пользователя

```bash
amba-tool user create username
```

```bash
samba-tool user create ivanov P@ssw0rd \
    --login-shell=/bin/bash \
    --gecos='Иван Иванов' \
    --given-name=Иван --surname=Иванов 
```

### Отключить устаревание пароля для пользователя

```bash
samba-tool user setexpiry ivanov --noexpiry 
```

### Удалить пользователя

```bash
samba-tool user delete username
```

### Создать группу

```bash
samba-tool group add groupname
```

### Удалить группу

```bash
samba-tool group delete groupname
```

### Добавить пользователей в группу

```bash
samba-tool group addmembers "Domain Users" user[,otheruser[,thirduser[,...]]]
```

### Удалить пользователей из группы

```bash
samba-tool group removemembers "Domain Users" user[,otheruser[,thirduser[,...]]]
```

### Показать пользователей группы

```bash
samba-tool group listmembers "Domain Users"
```

## Работа со встроенным в Samba 4 DNS сервером

### Запрос списка зон

```bash
samba-tool dns zonelist 127.0.0.1 -U Administrator
```

### Запрос информации о DNS зоне

```bash
samba-tool dns zoneinfo 127.0.0.1 local.acisi.ru -U Administrator
```

### Запрос всех DNS записей

```bash
samba-tool dns query 127.0.0.1 local.acisi.ru @ ALL -U Administrator
```

### Смена типа DNS сервера (Встроенный/Bind9)

```bash
samba_upgradedns --dns-backend=[BIND9_DLZ|SAMBA_INTERNAL]
```

### Создание записи типа А

```bash
samba-tool dns add 10.10.120.24 alt.lan COMP2 A 10.10.120.25 -Uadministrator
```

### Создание зоны обратного просмотра для сети 192.168.13.0/24

```bash
samba-tool dns zonecreate 127.0.0.1 13.168.192.in-addr.arpa -Uadministrator
```

### Создание записи в зоне обратного просмотра для узла dc1.alt.lan с адресом 192.168.13.139

```bash
samba-tool dns add 127.0.0.1 13.168.192.in-addr.arpa 139 PTR dc1.alt.lan -Uadministrator --password=P@ssw0rd
```

### Запрос записей в зоне обратного просмотра

```bash
samba-tool dns query 127.0.0.1 13.168.192.in-addr.arpa @ ALL -U Administrator
```

### Специфичные запросы

```bash
dig _msdcs.local.acisi.ru @127.0.0.1 SOA
```
